Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -997,45 +770,63 @@
                     me->dummyfcb->reparse_xattr_changed = me->fileref->fcb->reparse_xattr_changed;
                     me->dummyfcb->ea_changed = me->fileref->fcb->ea_changed;
                 }
-                
+
                 me->dummyfcb->created = me->fileref->fcb->created;
                 me->dummyfcb->deleted = me->fileref->fcb->deleted;
                 mark_fcb_dirty(me->dummyfcb);
-                
+
                 if (!me->fileref->fcb->ads) {
                     LIST_ENTRY* le2;
-                    
+
                     me->fileref->fcb->subvol = destdir->fcb->subvol;
                     me->fileref->fcb->inode = InterlockedIncrement64(&destdir->fcb->subvol->lastinode);
                     me->fileref->fcb->inode_item.st_nlink = 1;
-                    
-                    defda = get_file_attributes(me->fileref->fcb->Vcb, &me->fileref->fcb->inode_item, me->fileref->fcb->subvol, me->fileref->fcb->inode,
-                                                me->fileref->fcb->type, me->fileref->filepart.Length > 0 && me->fileref->filepart.Buffer[0] == '.', TRUE, Irp);
-                    
+
+                    defda = get_file_attributes(me->fileref->fcb->Vcb, me->fileref->fcb->subvol, me->fileref->fcb->inode,
+                                                me->fileref->fcb->type, me->fileref->dc && me->fileref->dc->name.Length >= sizeof(WCHAR) && me->fileref->dc->name.Buffer[0] == '.',
+                                                TRUE, Irp);
+
                     me->fileref->fcb->sd_dirty = !!me->fileref->fcb->sd;
                     me->fileref->fcb->atts_changed = defda != me->fileref->fcb->atts;
                     me->fileref->fcb->extents_changed = !IsListEmpty(&me->fileref->fcb->extents);
                     me->fileref->fcb->reparse_xattr_changed = !!me->fileref->fcb->reparse_xattr.Buffer;
                     me->fileref->fcb->ea_changed = !!me->fileref->fcb->ea_xattr.Buffer;
+                    me->fileref->fcb->xattrs_changed = !IsListEmpty(&me->fileref->fcb->xattrs);
                     me->fileref->fcb->inode_item_changed = TRUE;
-                    
+
+                    le2 = me->fileref->fcb->xattrs.Flink;
+                    while (le2 != &me->fileref->fcb->xattrs) {
+                        xattr* xa = CONTAINING_RECORD(le2, xattr, list_entry);
+
+                        xa->dirty = TRUE;
+
+                        le2 = le2->Flink;
+                    }
+
+                    if (le == move_list.Flink) { // first entry
+                        me->fileref->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
+                        me->fileref->fcb->inode_item.sequence++;
+
+                        if (!ccb->user_set_change_time)
+                            me->fileref->fcb->inode_item.st_ctime = now;
+                    }
+
                     le2 = me->fileref->fcb->extents.Flink;
                     while (le2 != &me->fileref->fcb->extents) {
                         extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-                        
-                        if (!ext->ignore && ext->datalen >= sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2) &&
-                            (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                                        
+
+                        if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
                             if (ed2->size != 0) {
                                 chunk* c = get_chunk_from_address(me->fileref->fcb->Vcb, ed2->address);
-                                
+
                                 if (!c) {
                                     ERR("get_chunk_from_address(%llx) failed\n", ed2->address);
                                 } else {
                                     Status = update_changed_extent_ref(me->fileref->fcb->Vcb, c, ed2->address, ed2->size, me->fileref->fcb->subvol->id, me->fileref->fcb->inode,
                                                                        ext->offset - ed2->offset, 1, me->fileref->fcb->inode_item.flags & BTRFS_INODE_NODATASUM, FALSE, Irp);
-                                    
+
                                     if (!NT_SUCCESS(Status)) {
                                         ERR("update_changed_extent_ref returned %08x\n", Status);
                                         ExReleaseResourceLite(me->fileref->fcb->Header.Resource);
@@ -1042,10 +833,10 @@
                                         goto end;
                                     }
                                 }
-                            
+
                             }
                         }
-                        
+
                         le2 = le2->Flink;
                     }
                 } else {
@@ -1052,61 +843,60 @@
                     me->fileref->fcb->subvol = me->parent->fileref->fcb->subvol;
                     me->fileref->fcb->inode = me->parent->fileref->fcb->inode;
                 }
-                
+
                 me->fileref->fcb->created = TRUE;
-                
+
                 InsertHeadList(&me->fileref->fcb->list_entry, &me->dummyfcb->list_entry);
                 RemoveEntryList(&me->fileref->fcb->list_entry);
-                
-                le = destdir->fcb->subvol->fcbs.Flink;
-                while (le != &destdir->fcb->subvol->fcbs) {
-                    fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
-                    
+
+                le3 = destdir->fcb->subvol->fcbs.Flink;
+                while (le3 != &destdir->fcb->subvol->fcbs) {
+                    fcb* fcb = CONTAINING_RECORD(le3, struct _fcb, list_entry);
+
                     if (fcb->inode > me->fileref->fcb->inode) {
-                        InsertHeadList(le->Blink, &me->fileref->fcb->list_entry);
+                        InsertHeadList(le3->Blink, &me->fileref->fcb->list_entry);
                         inserted = TRUE;
                         break;
                     }
-                    
-                    le = le->Flink;
+
+                    le3 = le3->Flink;
                 }
-                
+
                 if (!inserted)
                     InsertTailList(&destdir->fcb->subvol->fcbs, &me->fileref->fcb->list_entry);
-                
+
                 InsertTailList(&me->fileref->fcb->Vcb->all_fcbs, &me->dummyfcb->list_entry_all);
-                
+
                 while (!IsListEmpty(&me->fileref->fcb->hardlinks)) {
-                    LIST_ENTRY* le = RemoveHeadList(&me->fileref->fcb->hardlinks);
-                    hardlink* hl = CONTAINING_RECORD(le, hardlink, list_entry);
-                    
+                    hardlink* hl = CONTAINING_RECORD(RemoveHeadList(&me->fileref->fcb->hardlinks), hardlink, list_entry);
+
                     if (hl->name.Buffer)
                         ExFreePool(hl->name.Buffer);
-                    
+
                     if (hl->utf8.Buffer)
                         ExFreePool(hl->utf8.Buffer);
 
                     ExFreePool(hl);
                 }
-                
+
                 me->fileref->fcb->inode_item_changed = TRUE;
                 mark_fcb_dirty(me->fileref->fcb);
-                
+
                 if ((!me->dummyfcb->ads && me->dummyfcb->inode_item.st_nlink > 1) || (me->dummyfcb->ads && me->parent->dummyfcb->inode_item.st_nlink > 1)) {
                     LIST_ENTRY* le2 = le->Flink;
-                    
+
                     while (le2 != &move_list) {
                         move_entry* me2 = CONTAINING_RECORD(le2, move_entry, list_entry);
-                        
+
                         if (me2->fileref->fcb == me->fileref->fcb && !me2->fileref->fcb->ads) {
                             me2->dummyfcb = me->dummyfcb;
                             InterlockedIncrement(&me->dummyfcb->refcount);
                         }
-                        
+
                         le2 = le2->Flink;
                     }
                 }
-                
+
                 ExReleaseResourceLite(me->fileref->fcb->Header.Resource);
             } else {
                 ExAcquireResourceExclusiveLite(me->fileref->fcb->Header.Resource, TRUE);
@@ -1115,116 +905,93 @@
                 ExReleaseResourceLite(me->fileref->fcb->Header.Resource);
             }
         }
-        
+
         le = le->Flink;
     }
-    
-    KeQuerySystemTime(&time);
-    win_time_to_unix(time, &now);
-    
+
     fileref->fcb->subvol->root_item.ctransid = fileref->fcb->Vcb->superblock.generation;
     fileref->fcb->subvol->root_item.ctime = now;
-    
+
     // loop through list and create new filerefs
-    
+
     le = move_list.Flink;
     while (le != &move_list) {
         hardlink* hl;
         BOOL name_changed = FALSE;
-        
+
         me = CONTAINING_RECORD(le, move_entry, list_entry);
-        
-        me->dummyfileref = create_fileref();
+
+        me->dummyfileref = create_fileref(fileref->fcb->Vcb);
         if (!me->dummyfileref) {
             ERR("out of memory\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        if (me->fileref->fcb->inode == SUBVOL_ROOT_INODE)
+
+        if (me->fileref->fcb == me->fileref->fcb->Vcb->dummy_fcb) {
+            root* r = me->parent ? me->parent->fileref->fcb->subvol : destdir->fcb->subvol;
+
+            Status = create_directory_fcb(me->fileref->fcb->Vcb, r, me->fileref->parent->fcb, &me->fileref->fcb);
+            if (!NT_SUCCESS(Status)) {
+                ERR("create_directory_fcb returnd %08x\n", Status);
+                goto end;
+            }
+
+            me->fileref->dc->key.obj_id = me->fileref->fcb->inode;
+            me->fileref->dc->key.obj_type = TYPE_INODE_ITEM;
+
+            me->dummyfileref->fcb = me->fileref->fcb->Vcb->dummy_fcb;
+        } else if (me->fileref->fcb->inode == SUBVOL_ROOT_INODE) {
             me->dummyfileref->fcb = me->fileref->fcb;
-        else
+
+            me->fileref->fcb->subvol->parent = le == move_list.Flink ? destdir->fcb->subvol->id : me->parent->fileref->fcb->subvol->id;
+        } else
             me->dummyfileref->fcb = me->dummyfcb;
-        
+
         InterlockedIncrement(&me->dummyfileref->fcb->refcount);
 
-        me->dummyfileref->filepart = me->fileref->filepart;
-        
-        if (le == move_list.Flink) // first item
-            me->fileref->filepart.Length = me->fileref->filepart.MaximumLength = fnus->Length;
-        else
-            me->fileref->filepart.MaximumLength = me->fileref->filepart.Length;
-        
-        me->fileref->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart.MaximumLength, ALLOC_TAG);
-        
-        if (!me->fileref->filepart.Buffer) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        RtlCopyMemory(me->fileref->filepart.Buffer, le == move_list.Flink ? fnus->Buffer : me->dummyfileref->filepart.Buffer, me->fileref->filepart.Length);
-        
-        Status = RtlUpcaseUnicodeString(&me->fileref->filepart_uc, &me->fileref->filepart, TRUE);
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-            goto end;
-        }
-        
-        me->dummyfileref->utf8 = me->fileref->utf8;
         me->dummyfileref->oldutf8 = me->fileref->oldutf8;
-        
-        if (le == move_list.Flink) {
-            if (me->fileref->utf8.Length != utf8->Length || RtlCompareMemory(me->fileref->utf8.Buffer, utf8->Buffer, utf8->Length) != utf8->Length)
-                name_changed = TRUE;
-            
-            me->fileref->utf8.Length = me->fileref->utf8.MaximumLength = utf8->Length;
-        } else
-            me->fileref->utf8.MaximumLength = me->fileref->utf8.Length;
-        
-        if (me->fileref->utf8.MaximumLength > 0) {
-            me->fileref->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->utf8.MaximumLength, ALLOC_TAG);
-            
-            if (!me->fileref->utf8.Buffer) {
+        me->dummyfileref->oldindex = me->fileref->dc->index;
+
+        if (le == move_list.Flink && (me->fileref->dc->utf8.Length != utf8->Length || RtlCompareMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length) != utf8->Length))
+            name_changed = TRUE;
+
+        if ((le == move_list.Flink || me->fileref->fcb->inode == SUBVOL_ROOT_INODE) && !me->dummyfileref->oldutf8.Buffer) {
+            me->dummyfileref->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->dc->utf8.Length, ALLOC_TAG);
+            if (!me->dummyfileref->oldutf8.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
-            RtlCopyMemory(me->fileref->utf8.Buffer, le == move_list.Flink ? utf8->Buffer : me->dummyfileref->utf8.Buffer, me->fileref->utf8.Length);
+
+            RtlCopyMemory(me->dummyfileref->oldutf8.Buffer, me->fileref->dc->utf8.Buffer, me->fileref->dc->utf8.Length);
+
+            me->dummyfileref->oldutf8.Length = me->dummyfileref->oldutf8.MaximumLength = me->fileref->dc->utf8.Length;
         }
-        
+
         me->dummyfileref->delete_on_close = me->fileref->delete_on_close;
         me->dummyfileref->deleted = me->fileref->deleted;
-        
+
         me->dummyfileref->created = me->fileref->created;
         me->fileref->created = TRUE;
-        
+
         me->dummyfileref->parent = me->parent ? me->parent->dummyfileref : origparent;
         increase_fileref_refcount(me->dummyfileref->parent);
-        
-        me->dummyfileref->index = me->fileref->index;
 
-        insert_fileref_child(me->dummyfileref->parent, me->dummyfileref, TRUE);
-       
+        ExAcquireResourceExclusiveLite(&me->dummyfileref->parent->nonpaged->children_lock, TRUE);
+        InsertTailList(&me->dummyfileref->parent->children, &me->dummyfileref->list_entry);
+        ExReleaseResourceLite(&me->dummyfileref->parent->nonpaged->children_lock);
+
         me->dummyfileref->debug_desc = me->fileref->debug_desc;
-        
+
         if (me->dummyfileref->fcb->type == BTRFS_TYPE_DIRECTORY)
             me->dummyfileref->fcb->fileref = me->dummyfileref;
-        
+
         if (!me->parent) {
             RemoveEntryList(&me->fileref->list_entry);
-            
-            free_fileref(me->fileref->parent);
-            
+
             increase_fileref_refcount(destdir);
-            
-            Status = fcb_get_last_dir_index(destdir->fcb, &me->fileref->index, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("fcb_get_last_dir_index returned %08x\n", Status);
-                goto end;
-            }
-            
+
             if (me->fileref->dc) {
                 // remove from old parent
                 ExAcquireResourceExclusiveLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
@@ -1231,12 +998,20 @@
                 RemoveEntryList(&me->fileref->dc->list_entry_index);
                 remove_dir_child_from_hash_lists(me->fileref->parent->fcb, me->fileref->dc);
                 ExReleaseResourceLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock);
-                
+
+                me->fileref->parent->fcb->inode_item.st_size -= me->fileref->dc->utf8.Length * 2;
+                me->fileref->parent->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
+                me->fileref->parent->fcb->inode_item.sequence++;
+                me->fileref->parent->fcb->inode_item.st_ctime = now;
+                me->fileref->parent->fcb->inode_item.st_mtime = now;
+                me->fileref->parent->fcb->inode_item_changed = TRUE;
+                mark_fcb_dirty(me->fileref->parent->fcb);
+
                 if (name_changed) {
                     ExFreePool(me->fileref->dc->utf8.Buffer);
                     ExFreePool(me->fileref->dc->name.Buffer);
                     ExFreePool(me->fileref->dc->name_uc.Buffer);
-                    
+
                     me->fileref->dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8->Length, ALLOC_TAG);
                     if (!me->fileref->dc->utf8.Buffer) {
                         ERR("out of memory\n");
@@ -1243,47 +1018,59 @@
                         Status = STATUS_INSUFFICIENT_RESOURCES;
                         goto end;
                     }
-                    
-                    me->fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart.Length, ALLOC_TAG);
+
+                    me->fileref->dc->utf8.Length = me->fileref->dc->utf8.MaximumLength = utf8->Length;
+                    RtlCopyMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length);
+
+                    me->fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus->Length, ALLOC_TAG);
                     if (!me->fileref->dc->name.Buffer) {
                         ERR("out of memory\n");
                         Status = STATUS_INSUFFICIENT_RESOURCES;
                         goto end;
                     }
-                    
-                    me->fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart_uc.Length, ALLOC_TAG);
-                    if (!me->fileref->dc->name_uc.Buffer) {
-                        ERR("out of memory\n");
-                        Status = STATUS_INSUFFICIENT_RESOURCES;
+
+                    me->fileref->dc->name.Length = me->fileref->dc->name.MaximumLength = fnus->Length;
+                    RtlCopyMemory(me->fileref->dc->name.Buffer, fnus->Buffer, fnus->Length);
+
+                    Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                         goto end;
                     }
-                    
-                    me->fileref->dc->utf8.Length = me->fileref->dc->utf8.MaximumLength = utf8->Length;
-                    RtlCopyMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length);
-                    
-                    me->fileref->dc->name.Length = me->fileref->dc->name.MaximumLength = me->fileref->filepart.Length;
-                    RtlCopyMemory(me->fileref->dc->name.Buffer, me->fileref->filepart.Buffer, me->fileref->filepart.Length);
-                    
-                    me->fileref->dc->name_uc.Length = me->fileref->dc->name_uc.MaximumLength = me->fileref->filepart_uc.Length;
-                    RtlCopyMemory(me->fileref->dc->name_uc.Buffer, me->fileref->filepart_uc.Buffer, me->fileref->filepart_uc.Length);
-                    
+
                     me->fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)me->fileref->dc->name.Buffer, me->fileref->dc->name.Length);
                     me->fileref->dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)me->fileref->dc->name_uc.Buffer, me->fileref->dc->name_uc.Length);
                 }
-                
+
+                if (me->fileref->dc->key.obj_type == TYPE_INODE_ITEM)
+                    me->fileref->dc->key.obj_id = me->fileref->fcb->inode;
+
                 // add to new parent
+
                 ExAcquireResourceExclusiveLite(&destdir->fcb->nonpaged->dir_children_lock, TRUE);
+
+                if (IsListEmpty(&destdir->fcb->dir_children_index))
+                    me->fileref->dc->index = 2;
+                else {
+                    dir_child* dc2 = CONTAINING_RECORD(destdir->fcb->dir_children_index.Blink, dir_child, list_entry_index);
+
+                    me->fileref->dc->index = max(2, dc2->index + 1);
+                }
+
                 InsertTailList(&destdir->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
                 insert_dir_child_into_hash_lists(destdir->fcb, me->fileref->dc);
                 ExReleaseResourceLite(&destdir->fcb->nonpaged->dir_children_lock);
             }
-            
+
+            free_fileref(fileref->fcb->Vcb, me->fileref->parent);
             me->fileref->parent = destdir;
-            
-            insert_fileref_child(me->fileref->parent, me->fileref, TRUE);
-            
+
+            ExAcquireResourceExclusiveLite(&me->fileref->parent->nonpaged->children_lock, TRUE);
+            InsertTailList(&me->fileref->parent->children, &me->fileref->list_entry);
+            ExReleaseResourceLite(&me->fileref->parent->nonpaged->children_lock);
+
             TRACE("me->fileref->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", me->fileref->parent->fcb->inode, me->fileref->parent->fcb->inode_item.st_size);
-            me->fileref->parent->fcb->inode_item.st_size += me->fileref->utf8.Length * 2;
+            me->fileref->parent->fcb->inode_item.st_size += me->fileref->dc->utf8.Length * 2;
             TRACE("me->fileref->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", me->fileref->parent->fcb->inode, me->fileref->parent->fcb->inode_item.st_size);
             me->fileref->parent->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
             me->fileref->parent->fcb->inode_item.sequence++;
@@ -1291,11 +1078,40 @@
             me->fileref->parent->fcb->inode_item.st_mtime = now;
             me->fileref->parent->fcb->inode_item_changed = TRUE;
             mark_fcb_dirty(me->fileref->parent->fcb);
+        } else {
+            if (me->fileref->dc) {
+                ExAcquireResourceExclusiveLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
+                RemoveEntryList(&me->fileref->dc->list_entry_index);
+
+                if (!me->fileref->fcb->ads)
+                    remove_dir_child_from_hash_lists(me->fileref->parent->fcb, me->fileref->dc);
+
+                ExReleaseResourceLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock);
+
+                ExAcquireResourceExclusiveLite(&me->parent->fileref->fcb->nonpaged->dir_children_lock, TRUE);
+
+                if (me->fileref->fcb->ads)
+                    InsertHeadList(&me->parent->fileref->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
+                else {
+                    if (me->fileref->fcb->inode != SUBVOL_ROOT_INODE)
+                        me->fileref->dc->key.obj_id = me->fileref->fcb->inode;
+
+                    if (IsListEmpty(&me->parent->fileref->fcb->dir_children_index))
+                        me->fileref->dc->index = 2;
+                    else {
+                        dir_child* dc2 = CONTAINING_RECORD(me->parent->fileref->fcb->dir_children_index.Blink, dir_child, list_entry_index);
+
+                        me->fileref->dc->index = max(2, dc2->index + 1);
+                    }
+
+                    InsertTailList(&me->parent->fileref->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
+                    insert_dir_child_into_hash_lists(me->parent->fileref->fcb, me->fileref->dc);
+                }
+
+                ExReleaseResourceLite(&me->parent->fileref->fcb->nonpaged->dir_children_lock);
+            }
         }
 
-        if (me->fileref->fcb->inode == SUBVOL_ROOT_INODE)
-            me->fileref->fcb->subvol->root_item.num_references++;
-
         if (!me->dummyfileref->fcb->ads) {
             Status = delete_fileref(me->dummyfileref, NULL, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
@@ -1303,7 +1119,7 @@
                 goto end;
             }
         }
-        
+
         if (me->fileref->fcb->inode_item.st_nlink > 1) {
             hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
             if (!hl) {
@@ -1311,11 +1127,11 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
+
             hl->parent = me->fileref->parent->fcb->inode;
-            hl->index = me->fileref->index;
-            
-            hl->utf8.Length = hl->utf8.MaximumLength = me->fileref->utf8.Length;
+            hl->index = me->fileref->dc->index;
+
+            hl->utf8.Length = hl->utf8.MaximumLength = me->fileref->dc->utf8.Length;
             hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
             if (!hl->utf8.Buffer) {
                 ERR("out of memory\n");
@@ -1323,10 +1139,10 @@
                 ExFreePool(hl);
                 goto end;
             }
-            
-            RtlCopyMemory(hl->utf8.Buffer, me->fileref->utf8.Buffer, me->fileref->utf8.Length);
-            
-            hl->name.Length = hl->name.MaximumLength = me->fileref->filepart.Length;
+
+            RtlCopyMemory(hl->utf8.Buffer, me->fileref->dc->utf8.Buffer, me->fileref->dc->utf8.Length);
+
+            hl->name.Length = hl->name.MaximumLength = me->fileref->dc->name.Length;
             hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
             if (!hl->name.Buffer) {
                 ERR("out of memory\n");
@@ -1335,23 +1151,23 @@
                 ExFreePool(hl);
                 goto end;
             }
-            
-            RtlCopyMemory(hl->name.Buffer, me->fileref->filepart.Buffer, me->fileref->filepart.Length);
-            
+
+            RtlCopyMemory(hl->name.Buffer, me->fileref->dc->name.Buffer, me->fileref->dc->name.Length);
+
             InsertTailList(&me->fileref->fcb->hardlinks, &hl->list_entry);
         }
-        
+
         mark_fileref_dirty(me->fileref);
-        
+
         le = le->Flink;
     }
-    
+
     // loop through, and only mark streams as deleted if their parent inodes are also deleted
-    
+
     le = move_list.Flink;
     while (le != &move_list) {
         me = CONTAINING_RECORD(le, move_entry, list_entry);
-        
+
         if (me->dummyfileref->fcb->ads && me->parent->dummyfileref->fcb->deleted) {
             Status = delete_fileref(me->dummyfileref, NULL, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
@@ -1359,37 +1175,36 @@
                 goto end;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     destdir->fcb->subvol->root_item.ctransid = destdir->fcb->Vcb->superblock.generation;
     destdir->fcb->subvol->root_item.ctime = now;
-    
+
     me = CONTAINING_RECORD(move_list.Flink, move_entry, list_entry);
-    send_notification_fileref(me->dummyfileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
-    send_notification_fileref(fileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
-    send_notification_fileref(me->dummyfileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-    send_notification_fileref(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
+    send_notification_fileref(fileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, NULL);
+    send_notification_fileref(me->dummyfileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+    send_notification_fileref(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
 
     Status = STATUS_SUCCESS;
-    
+
 end:
     while (!IsListEmpty(&move_list)) {
         le = RemoveHeadList(&move_list);
         me = CONTAINING_RECORD(le, move_entry, list_entry);
-        
+
         if (me->dummyfcb)
-            free_fcb(me->dummyfcb);
-        
+            free_fcb(fileref->fcb->Vcb, me->dummyfcb);
+
         if (me->dummyfileref)
-            free_fileref(me->dummyfileref);
-        
-        free_fileref(me->fileref);
-        
+            free_fileref(fileref->fcb->Vcb, me->dummyfileref);
+
+        free_fileref(fileref->fcb->Vcb, me->fileref);
+
         ExFreePool(me);
     }
-    
+
     return Status;
 }
 
@@ -1397,99 +1212,98 @@
     BOOL inserted;
     LIST_ENTRY* le;
     UINT8 c, d;
-    
+
     c = dc->hash >> 24;
-    
+
     inserted = FALSE;
-    
+
     d = c;
     do {
         le = fcb->hash_ptrs[d];
-        
+
         if (d == 0)
             break;
-        
+
         d--;
     } while (!le);
-    
+
     if (!le)
         le = fcb->dir_children_hash.Flink;
-    
+
     while (le != &fcb->dir_children_hash) {
         dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_hash);
-        
+
         if (dc2->hash > dc->hash) {
             InsertHeadList(le->Blink, &dc->list_entry_hash);
             inserted = TRUE;
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!inserted)
         InsertTailList(&fcb->dir_children_hash, &dc->list_entry_hash);
-    
+
     if (!fcb->hash_ptrs[c])
         fcb->hash_ptrs[c] = &dc->list_entry_hash;
     else {
         dir_child* dc2 = CONTAINING_RECORD(fcb->hash_ptrs[c], dir_child, list_entry_hash);
-        
+
         if (dc2->hash > dc->hash)
             fcb->hash_ptrs[c] = &dc->list_entry_hash;
     }
-    
+
     c = dc->hash_uc >> 24;
-    
+
     inserted = FALSE;
-    
+
     d = c;
     do {
         le = fcb->hash_ptrs_uc[d];
-        
+
         if (d == 0)
             break;
-        
+
         d--;
     } while (!le);
-    
+
     if (!le)
         le = fcb->dir_children_hash_uc.Flink;
-    
+
     while (le != &fcb->dir_children_hash_uc) {
         dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_hash_uc);
-        
+
         if (dc2->hash_uc > dc->hash_uc) {
             InsertHeadList(le->Blink, &dc->list_entry_hash_uc);
             inserted = TRUE;
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!inserted)
         InsertTailList(&fcb->dir_children_hash_uc, &dc->list_entry_hash_uc);
-    
+
     if (!fcb->hash_ptrs_uc[c])
         fcb->hash_ptrs_uc[c] = &dc->list_entry_hash_uc;
     else {
         dir_child* dc2 = CONTAINING_RECORD(fcb->hash_ptrs_uc[c], dir_child, list_entry_hash_uc);
-        
+
         if (dc2->hash_uc > dc->hash_uc)
             fcb->hash_ptrs_uc[c] = &dc->list_entry_hash_uc;
     }
 }
 
-static NTSTATUS STDCALL set_rename_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, PFILE_OBJECT tfo) {
+static NTSTATUS set_rename_information(device_extension* Vcb, PIRP Irp, PFILE_OBJECT FileObject, PFILE_OBJECT tfo) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     FILE_RENAME_INFORMATION* fri = Irp->AssociatedIrp.SystemBuffer;
     fcb *fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
     file_ref *fileref = ccb ? ccb->fileref : NULL, *oldfileref = NULL, *related = NULL, *fr2 = NULL;
-    UINT64 index;
     WCHAR* fn;
-    ULONG fnlen, utf8len;
+    ULONG fnlen, utf8len, origutf8len;
     UNICODE_STRING fnus;
     ANSI_STRING utf8;
     NTSTATUS Status;
